******************************************************
*  Program...........: classes.prg
*  Author............: Lauren Clarke
*  Created...........: 06/4/2001
*  Project...........: FT Decorator article
*  Description.......: Classes from FT Decorator article
******************************************************

#DEFINE CR CHR(13)
#DEFINE INDENT CHR(9)

DEFINE CLASS DecoCust1 AS Relation

*-- data properties
cFName = ''
cLName=''
cPhone= ''
nCredLine = ''

*--- other properties
oData = NULL
cFullName = ''

FUNCTION cFName_Assign( tcValue)
THIS.oData.cFName=tcValue

FUNCTION cFName_Access()
RETURN This.oData.cFName

FUNCTION cPhone_Assign( tcValue)
THIS.oData.cPhone=tcValue

FUNCTION cPhone_Access()
RETURN This.oData.cPhone

FUNCTION cLName_Assign( tcValue)
This.oData.cLName=tcValue

FUNCTION clName_Access()
RETURN This.oData.cLName

FUNCTION nCredLine_Assign( tcValue)
This.oData.nCredLine=tcValue

FUNCTION nCredLine_Access()
RETURN This.oData.nCredLine

FUNCTION cFullName_Assign( tcValue)
LOCAL lnPos
lnPos = AT( " ",tcValue)
This.oData.cFname = LEFT(tcValue,lnPos)
This.oData.cLname = Substr(This.oData.cFname,lnpos,50)

FUNCTION cFullName_Access()
RETURN This.oData.cFname+" "+This.odata.cLname

FUNCTION INIT( toData)
This.oData = toData

FUNCTION isValid()
RETURN !EMPTY(This.oData.cFname) AND !EMPTY(This.oData.cLname)

FUNCTION ToXML()
*--- renders the object to xml
LOCAL lcRetval, lnTotalProps, lcProp, lcProp
LOCAL ARRAY laTemp[1]
lcRetval = [<?xml version="1.0"?>]+CR + ;
		   [<xdoc>]+ CR + ;
		   INDENT + [<cust>]+CR
lnTotalProps = AMEMBERS(laTemp,This.oData)

FOR lnK = 1 to lnTotalProps
  lcProp = LOWER(ALLTRIM(laTemp[lnK]))
  lcRetval = lcRetVal + REPLICATE(INDENT,2) + ;
             "<" + lcProp + ">" + ;
			 ALLTRIM(TRANSFORM(This.odata.&lcprop)) + ;
			 "</" + lcProp + ">" +CR
ENDFOR
lcRetval = lcRetval + INDENT + [</cust>]+CR+[</xdoc>]

RETURN lcRetval

FUNCTION Save()
GATHER NAME This.oData

FUNCTION DESTROY()
This.oData = NULL

ENDDEFINE

*=====================================
DEFINE CLASS DecoCust2Base as RELATION
*=====================================
* our generic decorator

oData = NULL

FUNCTION INIT( toData)
*-- add parameter checking here
THIS.oData = toData
ENDFUNC

FUNCTION THIS_ACCESS( tcMember)

IF PEMSTATUS(THIS,UPPER(tcMember),5)
  RETURN THIS
ELSE
  RETURN THIS.oData
ENDIF
ENDFUNC
  
FUNCTION DESTROY()
  THIS.oData = NULL

ENDDEFINE

*=====================================
DEFINE CLASS DecoCust2 as DecoCust2Base
*=====================================
cFullName = ''

FUNCTION cFullName_Assign( tcValue)
LOCAL lnPos
lnPos = AT( " ",tcValue)
This.oData.cFname = LEFT(tcValue,lnPos)
This.oData.cLname = Substr(This.oData.cFname,lnpos,50)

FUNCTION cFullName_Access()
RETURN This.oData.cFname+" "+This.odata.cLname

FUNCTION isValid()
RETURN !EMPTY(This.oData.cFname) AND !EMPTY(This.oData.cLname)

FUNCTION ToXML()
*--- renders the object to xml
LOCAL lcRetval, lnTotalProps, lcProp, lcProp
LOCAL ARRAY laTemp[1]
lcRetval = [<?xml version="1.0"?>]+CR + ;
		   [<xdoc>]+ CR + ;
		   INDENT + [<cust>]+CR
lnTotalProps = AMEMBERS(laTemp,This.oData)

FOR lnK = 1 to lnTotalProps
  lcProp = LOWER(ALLTRIM(laTemp[lnK]))
  lcRetval = lcRetVal + REPLICATE(INDENT,2) + ;
             "<" + lcProp + ">" + ;
			 ALLTRIM(TRANSFORM(This.odata.&lcprop)) + ;
			 "</" + lcProp + ">" +CR
ENDFOR
lcRetval = lcRetval + INDENT + [</cust>]+CR+[</xdoc>]

RETURN lcRetval

FUNCTION Save()
GATHER NAME This.oData

FUNCTION DESTROY()
This.oData = NULL

ENDDEFINE
