******************************************************
*  Program...........: perfcheck.prg
*  Author............: Lauren Clarke
*  Created...........: 06/8/2001
*  Project...........: FT Decorator article
*  Description.......: Produces a preformance report for pasting to Excel
******************************************************


#DEFINE ITERATIONS  100000
#DEFINE Ins_ITERATIONS  10000
#DEFINE TAB CHR(9)
#DEFINE CR CHR(13)

lcReport = "Task"+TAB+"Iterations"+TAB+"SubClass"+TAB+"Deco1"+TAB+"Deco2"+CR

loData = CREATE("Decorated")		&& a placeholder object 

WAIT WINDOW "Instantiation" NOWAIT

lnStart = Seconds()
FOR lnK = 1 to Ins_ITERATIONS
  lo0 = CREATE("SubClassPerfCheck")
ENDFOR
lnDeco0= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to Ins_ITERATIONS
  lo1 = CREATE("Deco1PerfCheck",loData )
ENDFOR
lnDeco1= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to Ins_ITERATIONS
  lo2 = CREATE("Deco2PerfCheck",loData )
ENDFOR
lnDeco2= seconds()-lnstart

lcReport = lcReport + "Instantiation"+TAB+STR(Ins_ITERATIONS)+TAB+TRANSFORM(lnDeco0)+TAB+TRANSFORM(lnDeco1)+TAB+TRANSFORM(lnDeco2)+CR

WAIT WINDOW "Access Decorator Property" NOWAIT

lnStart = Seconds()

FOR lnK = 1 to ITERATIONS
  lc = lo0.cProp1
ENDFOR
lnDeco0= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lc = lo1.cProp1
ENDFOR
lnDeco1= seconds()-lnstart
 
lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lc = lo2.cProp1
ENDFOR
lnDeco2= seconds()-lnstart

lcReport = lcReport + "Access Decorator Property"+TAB+Str(ITERATIONS)+TAB+TRANSFORM(lnDeco0)+TAB+TRANSFORM(lnDeco1)+TAB+TRANSFORM(lnDeco2)+CR

WAIT WINDOW "Assign Decorator Property" NOWAIT

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lo0.cProp1 = "Assign Test"
ENDFOR
lnDeco1= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lo1.cProp1 = "Assign Test"
ENDFOR
lnDeco1= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lo2.cProp1 = "Assign Test"
ENDFOR
lnDeco2= seconds()-lnstart

lcReport = lcReport + "Assign Decorator Property"+TAB+STR(ITERATIONS)+TAB+TRANSFORM(lnDeco0)+TAB+TRANSFORM(lnDeco1)+TAB+TRANSFORM(lnDeco2)+CR

WAIT WINDOW "Call Decorator Method" NOWAIT

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo0.Method1() 
ENDFOR
lnDeco0= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo1.Method1() 
ENDFOR
lnDeco1= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo2.Method1() 
ENDFOR
lnDeco2= seconds()-lnstart

lcReport = lcReport + "Call Decorator Method"+TAB+STR(ITERATIONS)+TAB+TRANSFORM(lnDeco0)+TAB+TRANSFORM(lnDeco1)+TAB+TRANSFORM(lnDeco2)+CR

WAIT WINDOW "Access Decorated Property" NOWAIT
lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo0.Name
ENDFOR
lnDeco0= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo1.Name
ENDFOR
lnDeco1= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo2.Name
ENDFOR
lnDeco2= seconds()-lnstart

lcReport = lcReport + "Access Decorated Property"+TAB+STR(ITERATIONS)+TAB+TRANSFORM(lnDeco0)+TAB+TRANSFORM(lnDeco1)+TAB+TRANSFORM(lnDeco2)+CR


WAIT WINDOW "Assign Decorated Property" NOWAIT
lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lo0.comment = "Assign Decorated Property"
ENDFOR
lnDeco0= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lo1.comment = "Assign Decorated Property"
ENDFOR
lnDeco1= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  lo2.comment = "Assign Decorated Property"
ENDFOR
lnDeco2= seconds()-lnstart

lcReport = lcReport + "Assign Decorated Property"+TAB+STR(ITERATIONS)+TAB+TRANSFORM(lnDeco0)+TAB+TRANSFORM(lnDeco1)+TAB+TRANSFORM(lnDeco2)+CR

WAIT WINDOW "Call Decorated Method" NOWAIT

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo0.MethodA() 
ENDFOR
lnDeco0= seconds()-lnstart


lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo1.MethodA() 
ENDFOR
lnDeco1= seconds()-lnstart

lnStart = Seconds()
FOR lnK = 1 to ITERATIONS
  x = lo2.MethodA() 
ENDFOR
lnDeco2= seconds()-lnstart

lcReport = lcReport + "Call Decorated Method"+TAB+STR(ITERATIONS)+TAB+TRANSFORM(lnDeco0)+TAB+TRANSFORM(lnDeco1)+TAB+TRANSFORM(lnDeco2)+CR+CR


_Cliptext = lcReport
WAIT WINDOW "Report is copied to Clipboard"

DEFINE CLASS Decorated as CUSTOM
FUNCTION MethodA() 
ENDDEFINE

*=====================================
DEFINE CLASS SubClassPerfCheck as Decorated
*=====================================
cProp1 = ''
FUNCTION METHOD1()
ENDDEFINE

*=====================================
DEFINE CLASS Deco1PerfCheck as Deco1
*=====================================
cProp1 = ''
FUNCTION METHOD1()
FUNCTION METHODA()
RETURN this.oDecorated.MethodA()
ENDDEFINE

*=====================================
DEFINE CLASS Deco2PerfCheck as Deco2
*=====================================
cProp1 = ''
FUNCTION METHOD1()
ENDDEFINE

*=====================================
DEFINE CLASS Deco1 AS RELATION
*=====================================
  oDecorated= .NULL.

  
  FUNCTION INIT( toDecorated)
  IF VARTYPE( toDecorated) = "O"
    THIS.oDecorated = toDecorated
  ENDIF
  
  FUNCTION DESTROY()
  This.oDecorated = .null.
ENDDEFINE


*=====================================
DEFINE CLASS Deco2 AS RELATION
*=====================================
  oDecorated= .NULL.

  FUNCTION INIT( toDecorated)
  IF VARTYPE( toDecorated) = "O"
    THIS.oDecorated = toDecorated
  ENDIF
  
  FUNCTION THIS_ACCESS( tcMember)
	
	IF PEMSTATUS(THIS,UPPER(tcMember),5)
		RETURN THIS
	ELSE
		RETURN THIS.oDecorated
	ENDIF
  ENDFUNC
  
  FUNCTION DESTROY()
  This.oDecorated = .null.
ENDDEFINE




