******************************************************
*  Program...........: sample.prg
*  Author............: Lauren Clarke
*  Created...........: 06/4/2001
*  Project...........: FT Decorator article
*  Description.......: Demonstration code from FT Decorator article
******************************************************

*-- NOTE: You'll want to change this path to match your situation
SET DEFA TO d:\FTDeco

*-- the decorator classes are in classes.prg
SET PROC TO classes.prg

IF !USED("cust")
  USE CUST in 0
ENDIF

SELECT cust
GO TOP
CLEAR 
*-- open debugger to step through examples
SET STEP ON 

SCATTER NAME loCust

*--- Manual pass-through code version
loCust = CREATE("DecoCust1",loCust)

*-- press F8 to step into these next few lines, note the pass-through code in action
? loCust.cFname
loCust.cFname = "Susie"
loCust.cLname = "Que"
*-- now we'll try some of our decorations
? loCust.cFullName
APPEND BLANK
loCust.Save()

*--- now, we'll clear everything and start over
loCust = NULL
GO TOP
SCATTER NAME loCust

*--- THIS_ACCESS delegation version
loCust = CREATE("DecoCust2",loCust)
*-- press F8 to step into these next few lines, note the THIS_ACCESS delegation
? loCust.cFname
loCust.cFname = "Susie"
loCust.cLname = "Que"
? loCust.cFullName
APPEND BLANK
loCust.Save()

*--- WITH/ENDWITH workaround example
SCATTER NAME loCust BLANK
loCust = CREATE("DecoCust2",loCust)

* this won't work
*!*	WITH loCust
*!*	  .cFname = "Billy"
*!*	  .cLName="Bob"
*!*	  .cPhone="123.456.7890"
*!*	ENDWITH

* This will work
WITH loCust.oData
  .cFname = "Billy"
  .cLName="Bob"
  .cPhone="123.456.7890"
ENDWITH

? loCust.cFullName, loCust.cPhone

*-- paste this into a text editor to see the xml rendering
_cliptext = loCust.toXML()

